"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const addHelpCommandToCli_1 = require("./addHelpCommandToCli");
const getRecommendCommand_1 = require("./recommend/getRecommendCommand");
const getShowUsage_1 = require("./usage/getShowUsage");
const runCliRecursive_1 = require("./runCliRecursive");
const runCli = async function ({ rootCommand, argv }) {
    const extendedRootCommand = addHelpCommandToCli_1.addHelpCommandToCli({ rootCommand });
    const recommendCommand = getRecommendCommand_1.getRecommendCommand({ rootCommand: extendedRootCommand });
    const showUsage = getShowUsage_1.getShowUsage({ rootCommand: extendedRootCommand });
    await runCliRecursive_1.runCliRecursive({
        command: extendedRootCommand,
        argv,
        showUsage,
        recommendCommand,
        level: 0,
        ancestorOptions: {},
        ancestorNames: []
    });
};
exports.runCli = runCli;
